/*

DCT1D.c
version jeudi 18 avril 2002
(C) 2002 whygee@f-cpu.org

Winograd 8-bin DCT for a "baseline" JPG compressor.

Optimisation : final part, cleanup

Most comments from the precedent code version are removed, so it can
be integrated in another piece of software.

b2 bug corrected on Tue Dec 16 06:37:45 CET 2003

*/

sample
  R1, R2, R3, R4, R5, R6, R7, R8, R9, R10; /* temporary registers */

  R7 = a0 + a7;
  R6 = a1 + a6;
  R4 = a3 - a4;
  R5 = a1 - a6;
  R9 = a2 + a5;
  R10 = a3 + a4;
  R3 = a2 - a5;
  R8 = a0 - a7;

  R1 = R7 + R10;
  R2 = R6 - R9;
  R4 = R4 + R3;
  R3 = R5 + R3;
  R7 = R7 - R10;
  R5 = R5 + R8;
  R9 = R6 + R9;

  R3 = m1 * R3;
  R2 = R2 + R7;
  R6 = R4 - R5;

  R4 = m3 * R4;
  R5 = m4 * R5;
  R2 = m1 * R2;
  R6 = m2 * R6;

  S0 = R1 + R9;
  S4 = R1 - R9;

  R1 = R3 + R8;
  R3 = R8 - R3;
/* one free slot here : the multiply is not ready */
  S2 = R7 + R2;
  R4 = R4 + R6;
  S6 = R7 - R2;
  R2 = R5 + R6;

  S3 = R3 - R4;
  S5 = R3 + R4;
  S1 = R1 + R2;
  S7 = R1 - R2;
